﻿#includepath "/Applications/Adobe InDesign CS5/Scripts/Xml Rules"
#include "glue code.jsx"
//==================================================================
// Copyright 2011 L'Express de Toronto Inc.
// April 20, 2011
// Written by Kasyan Servetsky
// http://www.kasyan.ho.com.ua
// e-mail: askoldich@yahoo.com
//==================================================================
const gScriptName = "Top stories"; // Script name
const gScriptVersion = "2.0"; // Version

var gDoc = app.activeDocument;

var ruleSet = new Array ( new ProcessArticles );
var gObj = {}

with(gDoc) {                     
	var elements = xmlElements; 
	__processRuleSet(elements.item(0), ruleSet);
}

CreateDialog();

//===================================== FUNCTIONS  ======================================
function CreateDialog() {
	var i, j, obj, gr;
	var list = ["", "1", "2", "3", "4", "5"];
	var win = new Window("dialog", gScriptName + " - " + gScriptVersion);
	win.alignChildren = "fill";
	
	var panel = win.add("panel", undefined, "");
	panel.orientation = "row";
	panel.alignChildren = "top";
	
	var grColCount = 0;
	var count;

	for (i in gObj) {
		obj = gObj[i];
		//$.writeln(i);
		count = parseInt(i.substr(1));
		//$.writeln(count);
		
		if (count == 1 || ((count-1) % 10) == 0) {
			grColCount++;
			eval( "var grCol" + grColCount + " = panel.add('group');" );
			eval( "grCol" + grColCount + ".orientation = 'column';" );
			eval( "grCol" + grColCount + ".alignChildren = 'right';" );
		}
		eval( "var gr" + i + " = grCol" + grColCount + ".add('group');" );
		eval( "gr" + i + ".orientation = 'row';" );
		eval( "gr" + i + ".alignChildren = 'fill';" );
		eval( "gr" + i + ".add('statictext', undefined, obj.page + ' -');" );
		eval( "gr" + i + ".add('statictext', undefined, obj.txt);" );
		eval( "gr" + i + ".add('dropdownlist', undefined, list);" );
		eval( "gr" + i + ".children[2].onChange = CheckSelection;" );
		
		if (obj.rate != null) eval( "gr" + i + ".children[2].selection = " + Number(obj.rate) );
	}
	
	var grButtons = win.add("group");
	grButtons.orientation = "row";
	grButtons.alignment = "center";
	var oklBtn =grButtons.add("button", undefined, "OK", {name:"ok"});
	var cancelBtn = grButtons.add("button", undefined, "Annuler", {name:"cancel"});
	
	var showDialog = win.show();
	
	if (showDialog == 1) {
		for (j in gObj) {
			obj = gObj[j];
			try {
				eval( "obj.rate = " + eval( "gr" + j + ".children[2].selection.text;" ) );
			}
			catch(err) {
				//$.writeln(j + " - " + err);
				obj.rate = null;
			}
		}

		Main();
	}

	function CheckSelection() {
		var ddl;
		if (this.selection != null && this.selection.text != "") {
			//$.writeln("CheckSelection - this.selection.text - " + this.selection.text);
			
			try {
				for (a in gObj) {
					ddl = eval( "gr"+ a + ".children[2];" );
					//$.writeln("CheckSelection - ddl != null - " + (ddl != null) );
					if (ddl != this &&
						ddl.selection != null &&
						ddl.selection.text == this.selection.text )
					{
						ddl.selection = null;
					}
				}
			}
			catch(err) {}
			
		}
	}

}	
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ProcessArticles() {
	var i, currXmlElement;
	var counter = 1;
	this.name = "ProcessArticles";
	this.xpath = "/Root/article";
	this.apply = function(theElement, theRuleProcessor) {
		with(theElement) {
			//$.writeln(counter + " - " + theElement.markupTag.name);
			for (i = theElement.xmlElements.length-1; i >= 0; i--) {
				currXmlElement = theElement.xmlElements[i];
				if (currXmlElement.markupTag.name == "titre:principal") {
					if (theElement.xmlAttributes.itemByName("principal") != null) {
						attr = theElement.xmlAttributes.itemByName("principal").value;
					}
					else {
						attr = null;
					}
				
					var obj = {	txt:currXmlElement.contents.substr(0, 100), 
										xml:theElement, 
										page:currXmlElement.parentStory.textContainers[0].parentPage.name,
										rate:attr
									}
								
					eval( "gObj._" + counter + " = obj" );
					counter++;	
					//$.writeln("  " + counter + " - titre:principal - " + currXmlElement.markupTag.name);
				}
			}
		}
	}	
	return true;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function Main() {
	var i, obj, attr;
	for (i in gObj) {
		obj = gObj[i];
		if (obj.xml.xmlAttributes.itemByName("principal") != null) obj.xml.xmlAttributes.itemByName("principal").remove();
		if (obj.rate != null && obj.rate != "") attr = obj.xml.xmlAttributes.add("principal", String(obj.rate));
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------